clear
PeriodUnstableMai         % Considered period
WellSpecifications      % From given well specifications
Co=1.518;               % Gas distribution factor (stableNov, 2.1, 0.74)
%Co=1.313;

%Smoothing of the MPFM rate measurements

% %plot(dt,qw,dt,qw1);
   
myg= 1e-5;              % Pa*s  Viscosity of gas guess
IDvalve= 0.0054;        % m     Downhole valve diameter
Ac=pi/4*IDvalve^2;      % m2    Area of port size
%-----------------------Preallocating--------------------------------
k= 1;                   %       k=i-1, the previous value in the loop
n=Linj;
L=tid2-tid1+1;
tid2x=L+tid1-1;
time=dt56(tid1:tid2x);             % min   Time

Preallocating
Preallocating2
%-------Numerical Integration of the pressure along tubing--------
window=10;
qww=tsmovavg(qw(1:L),'e',window,1);
qoo=tsmovavg(qo(1:L),'e',window,1);
qgg=tsmovavg(qgp(1:L),'e',window,1);
%pgi=tsmovavg(pgi,'e',window,1);
%qgi=tsmovavg(qgi,'e',window,1);
%Along the rest of the tubing:
for j=(window):L               %time in minutes
%At the wellhead:
    deltat=j-0;
    Pg(1)=pgi(j)*10^5;
    Tgrad=(Tres-55)/Lres; 
    T=55+Tgrad*1+274.15;
    [Bga(1),rhoga(1)]=FVFannulus(gg,T,Pg(1));
    Qga(1)=qgi(j)/(60*60)*Bga(1);                     
    %Along the rest of the tubing:
    for i=2:Lres    %annulus
        T=55+Tgrad*i+274.15;        % K     Temperature at point i
        [Bga(i),rhoga(i)]=FVFannulus(gg,T,Pg(k));% Gas FVF in annulus
        Qga(i)=qgi(j)/(60*60)*Bga(i);
        if i<=Linj                      %       Above the gas injection valve
            Pg(i)=Pg(k)+g*rhoga(i);     % Pa    Gas pressure
        else                            %       Below the gas injection valve
            Pg(i)=Pg(k)+g*rhow;         % Pa    Gas pressure
        end
         Qg_inj=Qga(Linj);
         pGasInj(j)=Pg(Linj);
         k=k+1;
    end
    k=1;
    p(Linj)=pGasInj(j)-0.5*rhoga(Linj)*Qg_inj^2/Ac^2;                         
    T=55+Tgrad*1+274.15;                
    [Bg(Linj), Bo(Linj), rhoo, rhog, Rs(Linj)] = FVF (go, gg, T, p(Linj));   
    wor(j)=qww(j)/(qww(j)+qoo(j));
    Qg_tbg(Linj)=qgg(j)/(24*60*60)*Bg(Linj);
    vsg(Linj)=Qg_tbg(Linj)/At; 
    Ql(Linj)=(qww(j)+qoo(j)*Bo(Linj))/(24*60*60);
    vsl(Linj)=Ql(Linj)/At;
    yl(Linj)= 0.35;
    yg(Linj)=1-yl(Linj);
    for i=(Linj+1):Lres
        T=55+Tgrad*i+274.15;            % K     Temperature at point i
        myo=6e-8*(p(n)/10^5)^2-3.01e-5*p(n)/10^5+6.3348e-3;   % Pa*s  Oil viscosity
        [Bg(i),Bo(i),rhoo,rhog,Rs(i)]=FVF(go,gg,T,p(n));% Black oil correlation
        Qo(i)=qoo(j)/(24*60*60)*Bo(i);  % m3/s  Oil rate, reservoir condition
        Ql(i)=qww(j)/(24*60*60)+Qo(i);  % m3/s  Liquid rate
        Qg_tbg(i)=qgg(j)/(24*60*60)*Bg(i)-Qg_inj;
        rhol=rhoo*(1-wor(j))+rhow*wor(j);%kg/m3 Density of oil+water
        vsg(i)=Qg_tbg(i)/At;            % m/s   Gas superficial velocity
        vsl(i)=Ql(i)/At;                % m/s   Liquid superficial velocity
        vm(i)=vsl(i)+vsg(i);            % m/s   Mixture velocity 
        vc(i)=Co*vm(i);                    % m/s   Kinematic velocity
        yl(i)=0.5*sqrt((vsg(i)/vo+Co*vsl(i)/vo-1)^2+4*Co*vsl(i)/vo)-0.5*(vsg(i)/vo+Co*vsl(i)/vo-1);%  Liquid fraction
        yg(i)=1-yl(i);                  %       Gas fraction
        rhotp(i)=rhol*yl(i)+rhog*yg(i); % kg/m3 Density of two-phase mixture
        myw=2.414e-5*10^(247.8/(T-140));% Pa*s  Water viscosity
        myl=myo*(1-wor(j))+myw*wor(j);  % Pa*s  Liquid viscosity
        my=myl*yl(i)+myg*yg(i);         % Pa*s  Mixture viscosity
        Re=rhotp(i)*vm(i)*d/my;         %       Reynolds number
        f(i)= Af*Re^(-Bf);              %       Friction factor (Blasius)
        p(i)=p(n)+g*rhotp(i)+0.5*f(i)*rhotp(i)/d*vm(i)^2; % Pa Pressure in point i
        
        n=n+1;                          %       Counter
        pDynInj(j)=p(Linj);
        pDynMfm(j)=p(Lmfm);
        pDynRes(j)=p(Lres);
    end
    n=Linj;
    for i=(Linj-1):-1:1
        T=55+Tgrad*i+274.15;            % K     Temperature at point i
        myo=6e-8*(p(n)/10^5)^2-3.01e-5*p(n)/10^5+6.3348e-3;   % Pa*s  Oil viscosity
        [Bg(i),Bo(i),rhoo,rhog,Rs(i)]=FVF(go,gg,T,p(n));% Black oil correlation
        Qo(i)=qoo(j)/(24*60*60)*Bo(i);  % m3/s  Oil rate, reservoir condition
        Ql(i)=qww(j)/(24*60*60)+Qo(i);  % m3/s  Liquid rate
        Qg_tbg(i)=qgg(j)/(24*60*60)*Bg(i);
        rhol=rhoo*(1-wor(j))+rhow*wor(j);%kg/m3 Density of oil+water
        vsg(i)=Qg_tbg(i)/At;            % m/s   Gas superficial velocity
        vsl(i)=Ql(i)/At;                % m/s   Liquid superficial velocity
        vm(i)=vsl(i)+vsg(i);            % m/s   Mixture velocity 
        vc(i)=Co*vm(i);                % m/s   Kinematic velocity
        yl(i)=0.5*sqrt((vsg(i)/vo+Co*vsl(i)/vo-1)^2+4*Co*vsl(i)/vo)...
            -0.5*(vsg(i)/vo+Co*vsl(i)/vo-1);%  Liquid fraction
        yg(i)=1-yl(i);                  %       Gas fraction
        rhotp(i)=rhol*yl(i)+rhog*yg(i); % kg/m3 Density of two-phase mixture
        myw=2.414e-5*10^(247.8/(T-140));% Pa*s  Water viscosity
        myl=myo*(1-wor(j))+myw*wor(j);  % Pa*s  Liquid viscosity
        my=myl*yl(i)+myg*yg(i);         % Pa*s  Mixture viscosity
        Re=rhotp(i)*vm(i)*d/my;         %       Reynolds number
        f(i)= Af*Re^(-Bf);              %       Friction factor (Blasius)
        p(i)=p(n)-g*rhotp(i)-0.5*f(i)*rhotp(i)/d*vm(i)^2; % Pa Pressure in point i

        n=n-1;                          %       Counter
        pDynTop(j)=p(1);
        QoTop(j)=Qo(1);
        QgTot(j)=Qg_tbg(1);
    end
    n=Linj;
    err(j)=pw56(find(dt56==deltat))-pDynMfm(j)./10^5;         %       Diff in the downhole pressures
    errTop(j)=pwh56(find(dt56==deltat))-pDynTop(j)./10^5;
    k=1;                                %       Reset counter
    %PlotStasjDynamisk
end
error=mean(abs(err))
errorTop=mean(abs(errTop))

figure(1)
 plot(time(10:(L)),pDynTop(1:(L-9))/10^5,'g',time(10:(L)),pDynInj(3:(L-7))/10^5,'k',...
     time(10:(L)),pDynMfm(8:(L-2))/10^5,'b',time(10:(L)),pDynRes(10:(L))/10^5,'m',...
     time(10:(L)),pwf(10:(L)),':b',time(10:(L)),pwh(10:(L)),':g')
%plot(time,pDynTop/10^5,'g',time,pDynInj/10^5,'k',time,pDynMfm/10^5,'b',...
 %   time,pDynRes/10^5,'m',time,pwf(1:L),':b',time,pwh(1:L),':g')
title('Pressure at Different Depths');
legend('Wellhead','Injection point','Gauge carrier','Bottomhole');
xlabel('\bf Time [hrs]');
ylabel('\bf Pressure [bar]');
axis([time(1) time(L) 0 200])

figure(2)
subplot(2,1,1)
plot(time(10:L),pDynMfm(8:(L-2))/10^5,'b',time(10:L),pwf(10:(L)),':b')
axis([448 450 80 150]);
title('Pressure at gauge carrier')
xlabel('Time [hrs]');
ylabel('Pressure [bar]');
subplot(2,1,2)
plot(time(10:L),pDynTop(1:(L-9))/10^5,'g',time(10:L),pwh(10:(L)),':g')
axis([448 450 0 40]);
title('Wellhead pressure')
xlabel('Time [hrs]');
ylabel('Pressure [bar]');
% figure(3)
% plot(time,pDynTop/10^5,'g',time,pwh(1:L),'r')
% axis([time(1) L 0 40]);

figure(5)
qll=qoo+qww;
ql=qo+qw;
%plot(time,qll,'k',time,ql(1:L),'.-r',time,mean(ql(1:L))*ones(1,L),'y')
%plot(time,QoTop*60*60*24,'k',time,qo(1:L),':r',time,qww,'b',time,qw(1:L),':r')
plot(time,qoo,'k',time,qo(1:L),':k',time,qww,'b',time,qw(1:L),':b')
axis([time(1) time(L) 0 1800])
legend('Estimated Qo','Measured Qo','Estimated Qw','Measured Qw');
title('Estimated and Measured Flow Rate');
xlabel('\bf Time [hrs]');
ylabel('\bf Flow rate [m3/s]');

% maxV=15;
% InjDepth=-Linj*ones(1,maxV);        % L      Gas injection valve depth
% MFMDepth=-Lmfm*ones(1,maxV);        % L      Multiphase flow meter depth
% ResDepth=-Lres*ones(1,maxV);        % L      Top of reservoir depth
% xv=[1:maxV]-1;
% figure(7)
% plot(-(1:Lres),vsg,-(1:Lres),vsl,InjDepth,xv,'--r',MFMDepth,xv,'--g',ResDepth,xv,'--m')
% legend('Gas','Liquid');
% title('Velocity Profile');
% xlabel('\bf Depth [m]');
% ylabel('\bf Velocity [m/s]');
% grid
% 
% %-----------Plot of the liquid fraction vs depth----------------
% maxV=2;
% InjDepth=-Linj*ones(1,maxV);        % L      Gas injection valve depth
% MFMDepth=-Lmfm*ones(1,maxV);        % L      Multiphase flow meter depth
% ResDepth=-Lres*ones(1,maxV);  %      % L      Top of reservoir depth
% xv=[1:maxV]-1;
% figure(8)
% plot(xv,InjDepth,'--r',xv,MFMDepth,'--g',xv,ResDepth,'--m',yl,-(1:Lres),'b')
% legend('Injection Depth','Measurement Depth', 'Reservoir Depth');
% title('Liquid Fraction vs Depth');
% xlabel('\bf Liquid fraction');
% ylabel('\bf Depth [m]');
% grid
