function [Bga,rhog, z ] = FVFannulus (gg, T, Pg)
% Calculations of formation volume factors
% p = Pressure at position i in the tubing
% T = Temperature at position i in the tubing
% gg = Gas specific gravity at surface conditions

rhg0=gg*1.23;       % kg/Sm3  Gas density at surface conditions

% Pseudocritical Temperature and Pressure
Tpc =94.0+194.2*gg-41.1*gg.^2;          
Ppc=1e5*(52.18-9.032*gg-0.248*gg.^2);
% Reduced Temperature and Pressure:
Tr=T/Tpc;
pR=Pg/Ppc;

[ z ] = zfak( pR,Tr,0.8);   % Yarborough and Hall (1974) EOS

% Calculating gas and oil FVF at position i
Bga =1.01e5/Pg*T/(273+15)*z;
% Calculating gas and oil density at position i
rhog=rhg0/Bga;
