%Unstable period from 19.01.17 15:00:00 to 20.01.17 17:00:00
%clear
load('JanFeb');

tidstart=444; %447
tidend=452;     %473
tid1=find(dt12==tidstart);
tid2=find(dt12==tidend);
dt=dt12(tid1:tid2);

L=tid2-tid1+1;
Ql=qo12(tid1:tid2)+qw12(tid1:tid2);
snitt=mean(Ql);
y1=snitt*ones(1,L);
sum=0;
for k=1:L
    varu=(Ql(k)-snitt)^2;
    sum=sum+varu;
end
sum;
sigma=sqrt(sum/L);
y2=(snitt-sigma)*ones(1,L);
y3=(snitt+sigma)*ones(1,L);

window=50;
exp=tsmovavg(Ql,'e',window,1);

pgi=pgi12(tid1:tid2);
pwf=pw12(tid1:tid2);

% figure(11)
% plot(dt,Ql,'.-k', dt,y1,'--b',dt, exp, 'm',dt,y2,'--r',dt,y3,'--r');
% axis([448 453 0 3000]);
% title('5 hours of the Production in an Unstable Period 19.01.17');
% legend('Liquid Rate','Mean value','Exp mean','Deviation');
% %legend('Qo [Sm3/day]','Qgi [Sm3/hr]', 'Pw [bara]');
% xlabel('Time, t [hrs]');
% ylabel('Ql [Sm3/day]');
% %figure(12)
% %plot(dt,pgi,'b',dt,pwf,'r')

Pr=171;
Pw=mean(pw12(tid1:tid2));
Jw=mean(Ql)/(Pr-139);
qw=qw12(tid1:tid2);
qo=qo12(tid1:tid2);
qgp=qgp12(tid1:tid2);
qgi=qgi12(tid1:tid2);
pwh=pwh12(tid1:tid2);
twh=twh12(tid1:tid2);

wor=mean(qw)/(mean(qw+qo));

%----------------Stating and calculating variables-------------------
%Estimated from given well specifications and period
J= 25.6/(24*60*60)/10^5;     % Sm3/s/Pa   Productivity index 
WOR= mean(qw)/mean(qo);      % Sm3/Sm3    Water oil ratio
Qg_r= mean(qgp)/(24*60*60);  % Sm3/s      Total gas rate
pth=mean(pwh)*10^5;          % Pa         Tubing head pressure (mean(WHP))

% Gas properties
Qg_i=mean(qgi)/(60*60);      % Sm3/s      Lift-gas flow rate

% Assumed values
%Co= 1.9044;              %       Gas distribution parameter estimated
vo= 0.05;               %       Drift velocity
Af= 0.316;              %       Friction factor correlation parameter
Bf= 0.25;               %       Friction factor correlation exponent
%MFM=0.75;               %       MFM adjustment


figure(32)
subplot(2,1,1)
%Plot pwh, pwf, qgi, pgi, Ql,  qgp
%Se om det kan vre noen grunn til plutselige oscillasjoner
%Mai perioden er ogs god  bruke
plot(dt,pwh,'g',dt,pwf,'r',dt,pgi,'m')
title('Pressure')
ylabel('P [bar]')
xlabel('Time [hrs]')
legend('Wellhead','Tubing','Gas lift')

subplot(2,1,2)
plot(dt,Ql,'k',dt,qgp./200,'y',dt,qgi.*24./100,'m')
title('Flow rate')
ylim([0, 4000])
ylabel('Q [Sm3/day]')
xlabel('Time [hrs]')
legend('Liquid','Total gas/200','Lift-gas/100')

% normalen=normcdf(Ql,mean(Ql),500);
% norm=normcdf(Ql, mean(Ql), std(Ql));
% stdv=ones(1,L)*std(Ql);
% meanv=ones(1,L)*mean(Ql);
% figure(89)
% subplot(2,1,2)
% plot(Ql, norm,'.k')
% hold on
% plot(meanv',(0:(1/(L-1)):1),'r',(meanv'-stdv'),(0:(1/(L-1)):1),'b', (meanv'+stdv'),(0:(1/(L-1)):1),'b');
% hold on
% plot((meanv'-2*stdv'),(0:(1/(L-1)):1),'--b', (meanv'+2*stdv'),(0:(1/(L-1)):1),'--b');
% xlabel('Liquid Rate, [Sm3/day]');
% ylabel('Cumulative Distribution');
% title('Devation Around the Mean Value for High Oscillations in January');
% legend('Ql','Mean','Std');
% grid
% axis([-900 3700 0 1]);