%Unstable period from 19.12.16 05:01:00 to 20.12.16 23:01:00
%clear
load('MaiJuni');
%1157-1199, 164-323

tidstart=215; %220
tidend=225; %430
tid1=find(dt56==tidstart);
tid2=find(dt56==tidend);
dt=dt56(tid1:tid2);

L=tid2-tid1+1;
Ql=qo56(tid1:tid2)+qw56(tid1:tid2);
snitt=mean(Ql);
y1=snitt*ones(1,L);
sum=0;
for k=1:L
    varu=(Ql(k)-snitt)^2;
    sum=sum+varu;
end
sum;
sigma=sqrt(sum/L);
y2=(snitt-sigma)*ones(1,L);
y3=(snitt+sigma)*ones(1,L);

window=50;
exp=tsmovavg(Ql,'e',window,1);

% figure(11)
% plot(dt,Ql,'k', dt,exp,'y', dt,y1,'--b',dt,y2,'--m',dt,y3,'--m');
% axis([tidstart tidend 0 5000]);
% title('Graph of the Production in a unstable period in 19.12-20.12');
% %legend('Qo [Sm3/day]','Qgi [Sm3/hr]', 'Pw [bara]');
% xlabel('Time, t [hrs]');
% ylabel('Ql [Sm3/day]');


Pr=171;
Pw=mean(pw56(tid1:tid2));
Jw=mean(Ql)/(Pr-139);
qw=qw56(tid1:tid2);
qo=qo56(tid1:tid2);
qgp=qgp56(tid1:tid2);
qgi=qgi56(tid1:tid2);
pwh=pwh56(tid1:tid2);
pwf=pw56(tid1:tid2);
pgi=pgi56(tid1:tid2);
wor=mean(qw)/(mean(qw+qo));
twh=twh56(tid1:tid2);
%----------------Stating and calculating variables-------------------
%Estimated from given well specifications and period
J= 25.6/(24*60*60)/10^5;     % Sm3/s/Pa   Productivity index 
WOR= mean(qw)/mean(qo);      % Sm3/Sm3    Water oil ratio
Qg_r= mean(qgp)/(24*60*60);  % Sm3/s      Total gas rate
pth=mean(pwh)*10^5;          % Pa         Tubing head pressure (mean(WHP))

% Gas properties
Qg_i=mean(qgi)/(60*60);      % Sm3/s      Lift-gas flow rate

% Assumed values
%Co= 2.0482;             %       Gas distribution parameter estimated
vo= 0.05;               %       Drift velocity
Af= 0.316;              %       Friction factor correlation parameter
Bf= 0.25;               %       Friction factor correlation exponent
%MFM=0.75;               %       MFM adjustment

figure(32)
subplot(2,1,1)
%Plot pwh, pwf, qgi, pgi, Ql,  qgp
%Se om det kan vre noen grunn til plutselige oscillasjoner
%Mai perioden er ogs god  bruke
plot(dt,pwh,'g',dt,pwf,'r',dt,pgi,'m')
title('Pressure')
ylabel('Pressure [bar]')
xlabel('Time [hrs]')
legend('Wellhead','Tubing','Gas lift')

subplot(2,1,2)
plot(dt,Ql,'k',dt,qgp./200,'y',dt,qgi.*24./100,'m')
title('Flow rate')
ylabel('Flow rate [Sm3/day]')
xlabel('Time [hrs]')
legend('Liquid','Total gas/200','Lift gas/100')