%----------------Stating and calculating variables-------------------
% Constant parameters
g= 9.81;                % m/s2   Gravity
Lres= 2913;             % m      Total length down to reservoir
Linj= 1827;             % m      Gas injection valve depth
Lmfm= 2671;             % m      Multiphase Flow Meter depth
d= 4.778*0.0254;        % m      Tubing inner diameter
ODtbg= 5.5*0.0254;      % m      Tubing outer diameter
IDcsg= 8.54*0.0254;     % m      Casing inner diameter
IDvalve= 23/64*0.0254;  % m      Downhole valve diameter
rhow= 1000;             % kg/m3  Density of water (assumed incompressible)
Pr= 171*10^5;           % Pa     Reservoir pressure
E= 0.002;               %        Roughness for stainless steel
vo= 0.2;               %        Drift velocity
Af= 0.316;              %        Friction factor correlation parameter
Bf= 0.25;               %        Friction factor correlation exponent

% Calculations of area, volume, rate etc.
Ac= pi/4*IDvalve^2;             % m2    Area of port size
At= pi/4*d^2;                   % m2    Cross-sectional area of tubing
Vt= pi/4*d^2*Lres;              % m3    Tubing volum
Va= pi/4*(IDcsg-ODtbg)^2*Lres;  % m3    Annulus volum
%T1= 5;                          % C     Surface temperature
Tres= 85;                       % C     Reservoir temperature
%Tgrad= (Tres-T1)/Lres;          % C     Geothermal gradient

% Gas and oil properties
BoRes=1.143;            % m3/Sm3 Bo at reservoir
goRes= 0.8349;          %        Oil spesific gravity in reservoir
go=goRes*BoRes;         %        Oil spesific gravity at surface conditions
gg= 0.606;              %        Gas specific gravity at surface conditions

% Standard conditions
R=8.414472*10^6;        % cm3Pa/K/mol  Gas constant
To=288.15;              % K      Standard temperature for natural gas
po=101.325*10^3;        % Pa     Standard pressure for a natural gas


